Index: drivers/filesystems/btrfs/write.c
===================================================================
--- drivers/filesystems/btrfs/write.c	(révision 75772)
+++ drivers/filesystems/btrfs/write.c	(copie de travail)
@@ -2724,195 +2916,251 @@
                 break;
             } else if (nextext->offset > start_data)
                 break;
-            
+
             ext = nextext;
         }
-        
+
         le = le->Flink;
     }
-    
+
     if (!ext)
         return FALSE;
 
-    ed = ext->data;
-    
-    if (ext->datalen < sizeof(EXTENT_DATA)) {
-        ERR("extent %llx was %u bytes, expected at least %u\n", ext->offset, ext->datalen, sizeof(EXTENT_DATA));
-        return FALSE;
-    }
-    
+    ed = &ext->extent_data;
+
     if (ed->type != EXTENT_TYPE_REGULAR && ed->type != EXTENT_TYPE_PREALLOC) {
         TRACE("not extending extent which is not regular or prealloc\n");
         return FALSE;
     }
-    
+
     ed2 = (EXTENT_DATA2*)ed->data;
-    
-    if (ext->datalen < sizeof(EXTENT_DATA) - 1 + sizeof(EXTENT_DATA2)) {
-        ERR("extent %llx was %u bytes, expected at least %u\n", ext->offset, ext->datalen, sizeof(EXTENT_DATA) - 1 + sizeof(EXTENT_DATA2));
-        return FALSE;
-    }
 
     if (ext->offset + ed2->num_bytes != start_data) {
         TRACE("last EXTENT_DATA does not run up to start_data (%llx + %llx != %llx)\n", ext->offset, ed2->num_bytes, start_data);
         return FALSE;
     }
-    
+
     c = get_chunk_from_address(Vcb, ed2->address);
-    
+
     if (c->reloc || c->readonly || c->chunk_item->type != Vcb->data_flags)
         return FALSE;
-    
+
     ExAcquireResourceExclusiveLite(&c->lock, TRUE);
-    
+
+    if (length > c->chunk_item->size - c->used) {
+        ExReleaseResourceLite(&c->lock);
+        return FALSE;
+    }
+
+    if (!c->cache_loaded) {
+        NTSTATUS Status = load_cache_chunk(Vcb, c, NULL);
+
+        if (!NT_SUCCESS(Status)) {
+            ERR("load_cache_chunk returned %08x\n", Status);
+            ExReleaseResourceLite(&c->lock);
+            return FALSE;
+        }
+    }
+
     le = c->space.Flink;
     while (le != &c->space) {
-        s = CONTAINING_RECORD(le, space, list_entry);
-        
+        space* s = CONTAINING_RECORD(le, space, list_entry);
+
         if (s->address == ed2->address + ed2->size) {
             UINT64 newlen = min(min(s->size, length), MAX_EXTENT_SIZE);
-            
-            success = insert_extent_chunk(Vcb, fcb, c, start_data, newlen, FALSE, data, Irp, rollback, BTRFS_COMPRESSION_NONE, newlen);
-            
+
+            success = insert_extent_chunk(Vcb, fcb, c, start_data, newlen, FALSE, data, Irp, rollback, BTRFS_COMPRESSION_NONE, newlen, file_write, irp_offset);
+
             if (success)
                 *written += newlen;
-            
+            else
+                ExReleaseResourceLite(&c->lock);
+
             return success;
         } else if (s->address > ed2->address + ed2->size)
             break;
-        
+
         le = le->Flink;
     }
-    
+
     ExReleaseResourceLite(&c->lock);
-    
+
     return FALSE;
 }
 
+static NTSTATUS insert_chunk_fragmented(fcb* fcb, UINT64 start, UINT64 length, UINT8* data, BOOL prealloc, LIST_ENTRY* rollback) {
+    LIST_ENTRY* le;
+    UINT64 flags = fcb->Vcb->data_flags;
+    BOOL page_file = fcb->Header.Flags2 & FSRTL_FLAG2_IS_PAGING_FILE;
+    NTSTATUS Status;
+    chunk* c;
+
+    ExAcquireResourceSharedLite(&fcb->Vcb->chunk_lock, TRUE);
+
+    // first create as many chunks as we can
+    do {
+        Status = alloc_chunk(fcb->Vcb, flags, &c, FALSE);
+    } while (NT_SUCCESS(Status));
+
+    if (Status != STATUS_DISK_FULL) {
+        ERR("alloc_chunk returned %08x\n", Status);
+        ExReleaseResourceLite(&fcb->Vcb->chunk_lock);
+        return Status;
+    }
+
+    le = fcb->Vcb->chunks.Flink;
+    while (le != &fcb->Vcb->chunks) {
+        c = CONTAINING_RECORD(le, chunk, list_entry);
+
+        if (!c->readonly && !c->reloc) {
+            ExAcquireResourceExclusiveLite(&c->lock, TRUE);
+
+            if (c->chunk_item->type == flags) {
+                while (!IsListEmpty(&c->space_size) && length > 0) {
+                    space* s = CONTAINING_RECORD(c->space_size.Flink, space, list_entry_size);
+                    UINT64 extlen = min(length, s->size);
+
+                    if (insert_extent_chunk(fcb->Vcb, fcb, c, start, extlen, prealloc && !page_file, data, NULL, rollback, BTRFS_COMPRESSION_NONE, extlen, FALSE, 0)) {
+                        start += extlen;
+                        length -= extlen;
+                        if (data) data += extlen;
+
+                        ExAcquireResourceExclusiveLite(&c->lock, TRUE);
+                    }
+                }
+            }
+
+            ExReleaseResourceLite(&c->lock);
+
+            if (length == 0)
+                break;
+        }
+
+        le = le->Flink;
+    }
+
+    ExReleaseResourceLite(&fcb->Vcb->chunk_lock);
+
+    return length == 0 ? STATUS_SUCCESS : STATUS_DISK_FULL;
+}
+
 static NTSTATUS insert_prealloc_extent(fcb* fcb, UINT64 start, UINT64 length, LIST_ENTRY* rollback) {
     LIST_ENTRY* le;
     chunk* c;
-#ifdef __REACTOS__
     UINT64 flags;
-#else
-    UINT64 flags, origlength = length;
-#endif
     NTSTATUS Status;
     BOOL page_file = fcb->Header.Flags2 & FSRTL_FLAG2_IS_PAGING_FILE;
-    
+
     flags = fcb->Vcb->data_flags;
-    
-    // FIXME - try and maximize contiguous ranges first. If we can't do that,
-    // allocate all the free space we find until it's enough.
-    
+
     do {
         UINT64 extlen = min(MAX_EXTENT_SIZE, length);
-        
+
         ExAcquireResourceSharedLite(&fcb->Vcb->chunk_lock, TRUE);
-        
+
         le = fcb->Vcb->chunks.Flink;
         while (le != &fcb->Vcb->chunks) {
             c = CONTAINING_RECORD(le, chunk, list_entry);
-            
+
             if (!c->readonly && !c->reloc) {
                 ExAcquireResourceExclusiveLite(&c->lock, TRUE);
-                
+
                 if (c->chunk_item->type == flags && (c->chunk_item->size - c->used) >= extlen) {
-                    if (insert_extent_chunk(fcb->Vcb, fcb, c, start, extlen, !page_file, NULL, NULL, rollback, BTRFS_COMPRESSION_NONE, extlen)) {
+                    if (insert_extent_chunk(fcb->Vcb, fcb, c, start, extlen, !page_file, NULL, NULL, rollback, BTRFS_COMPRESSION_NONE, extlen, FALSE, 0)) {
                         ExReleaseResourceLite(&fcb->Vcb->chunk_lock);
                         goto cont;
                     }
                 }
-                
+
                 ExReleaseResourceLite(&c->lock);
             }
 
             le = le->Flink;
         }
-        
+
         ExReleaseResourceLite(&fcb->Vcb->chunk_lock);
-        
+
         ExAcquireResourceExclusiveLite(&fcb->Vcb->chunk_lock, TRUE);
-        
-        if ((c = alloc_chunk(fcb->Vcb, flags))) {
-            ExReleaseResourceLite(&fcb->Vcb->chunk_lock);
-            
-            ExAcquireResourceExclusiveLite(&c->lock, TRUE);
-            
-            if (c->chunk_item->type == flags && (c->chunk_item->size - c->used) >= extlen) {
-                if (insert_extent_chunk(fcb->Vcb, fcb, c, start, extlen, !page_file, NULL, NULL, rollback, BTRFS_COMPRESSION_NONE, extlen))
-                    goto cont;
-            }
-            
-            ExReleaseResourceLite(&c->lock);
-        } else
-            ExReleaseResourceLite(&fcb->Vcb->chunk_lock);
-        
-        WARN("couldn't find any data chunks with %llx bytes free\n", origlength);
-        Status = STATUS_DISK_FULL;
+
+        Status = alloc_chunk(fcb->Vcb, flags, &c, FALSE);
+
+        ExReleaseResourceLite(&fcb->Vcb->chunk_lock);
+
+        if (!NT_SUCCESS(Status)) {
+            ERR("alloc_chunk returned %08x\n", Status);
+            goto end;
+        }
+
+        ExAcquireResourceExclusiveLite(&c->lock, TRUE);
+
+        if (c->chunk_item->type == flags && (c->chunk_item->size - c->used) >= extlen) {
+            if (insert_extent_chunk(fcb->Vcb, fcb, c, start, extlen, !page_file, NULL, NULL, rollback, BTRFS_COMPRESSION_NONE, extlen, FALSE, 0))
+                goto cont;
+        }
+
+        ExReleaseResourceLite(&c->lock);
+
+        Status = insert_chunk_fragmented(fcb, start, length, NULL, TRUE, rollback);
+        if (!NT_SUCCESS(Status))
+            ERR("insert_chunk_fragmented returned %08x\n", Status);
+
         goto end;
-        
+
 cont:
         length -= extlen;
         start += extlen;
     } while (length > 0);
-    
+
     Status = STATUS_SUCCESS;
-    
+
 end:
     return Status;
 }
 
-// static void print_tree(tree* t) {
-//     LIST_ENTRY* le = t->itemlist.Flink;
-//     while (le != &t->itemlist) {
-//         tree_data* td = CONTAINING_RECORD(le, tree_data, list_entry);
-//         ERR("%llx,%x,%llx (ignore = %s)\n", td->key.obj_id, td->key.obj_type, td->key.offset, td->ignore ? "TRUE" : "FALSE");
-//         le = le->Flink;
-//     }
-// }
-
-NTSTATUS insert_extent(device_extension* Vcb, fcb* fcb, UINT64 start_data, UINT64 length, void* data, PIRP Irp, LIST_ENTRY* rollback) {
+static NTSTATUS insert_extent(device_extension* Vcb, fcb* fcb, UINT64 start_data, UINT64 length, void* data,
+                              PIRP Irp, BOOL file_write, UINT64 irp_offset, LIST_ENTRY* rollback) {
+    NTSTATUS Status;
     LIST_ENTRY* le;
     chunk* c;
     UINT64 flags, orig_length = length, written = 0;
-    
+
     TRACE("(%p, (%llx, %llx), %llx, %llx, %p)\n", Vcb, fcb->subvol->id, fcb->inode, start_data, length, data);
-    
+
     if (start_data > 0) {
-        try_extend_data(Vcb, fcb, start_data, length, data, Irp, &written, rollback);
-        
+        try_extend_data(Vcb, fcb, start_data, length, data, Irp, &written, file_write, irp_offset, rollback);
+
         if (written == length)
             return STATUS_SUCCESS;
         else if (written > 0) {
             start_data += written;
+            irp_offset += written;
             length -= written;
             data = &((UINT8*)data)[written];
         }
     }
-    
+
     flags = Vcb->data_flags;
-    
+
     while (written < orig_length) {
         UINT64 newlen = min(length, MAX_EXTENT_SIZE);
         BOOL done = FALSE;
-        
+
         // Rather than necessarily writing the whole extent at once, we deal with it in blocks of 128 MB.
         // First, see if we can write the extent part to an existing chunk.
-        
+
         ExAcquireResourceSharedLite(&Vcb->chunk_lock, TRUE);
-        
+
         le = Vcb->chunks.Flink;
         while (le != &Vcb->chunks) {
             c = CONTAINING_RECORD(le, chunk, list_entry);
-            
+
             if (!c->readonly && !c->reloc) {
                 ExAcquireResourceExclusiveLite(&c->lock, TRUE);
-                
+
                 if (c->chunk_item->type == flags && (c->chunk_item->size - c->used) >= newlen &&
-                    insert_extent_chunk(Vcb, fcb, c, start_data, newlen, FALSE, data, Irp, rollback, BTRFS_COMPRESSION_NONE, newlen)) {
+                    insert_extent_chunk(Vcb, fcb, c, start_data, newlen, FALSE, data, Irp, rollback, BTRFS_COMPRESSION_NONE, newlen, file_write, irp_offset)) {
                     written += newlen;
-                    
+
                     if (written == orig_length) {
                         ExReleaseResourceLite(&Vcb->chunk_lock);
                         return STATUS_SUCCESS;
@@ -2919,6 +3167,7 @@
                     } else {
                         done = TRUE;
                         start_data += newlen;
+                        irp_offset += newlen;
                         length -= newlen;
                         data = &((UINT8*)data)[newlen];
                         break;
@@ -2929,44 +3178,52 @@
 
             le = le->Flink;
         }
-        
-        ExReleaseResourceLite(&fcb->Vcb->chunk_lock);
-        
+
+        ExReleaseResourceLite(&Vcb->chunk_lock);
+
         if (done) continue;
-        
+
         // Otherwise, see if we can put it in a new chunk.
-        
-        ExAcquireResourceExclusiveLite(&fcb->Vcb->chunk_lock, TRUE);
-        
-        if ((c = alloc_chunk(Vcb, flags))) {
-            ExReleaseResourceLite(&Vcb->chunk_lock);
-            
+
+        ExAcquireResourceExclusiveLite(&Vcb->chunk_lock, TRUE);
+
+        Status = alloc_chunk(Vcb, flags, &c, FALSE);
+
+        ExReleaseResourceLite(&Vcb->chunk_lock);
+
+        if (!NT_SUCCESS(Status)) {
+            ERR("alloc_chunk returned %08x\n", Status);
+            return Status;
+        }
+
+        if (c) {
             ExAcquireResourceExclusiveLite(&c->lock, TRUE);
-            
+
             if (c->chunk_item->type == flags && (c->chunk_item->size - c->used) >= newlen &&
-                insert_extent_chunk(Vcb, fcb, c, start_data, newlen, FALSE, data, Irp, rollback, BTRFS_COMPRESSION_NONE, newlen)) {
+                insert_extent_chunk(Vcb, fcb, c, start_data, newlen, FALSE, data, Irp, rollback, BTRFS_COMPRESSION_NONE, newlen, file_write, irp_offset)) {
                 written += newlen;
-                
+
                 if (written == orig_length)
                     return STATUS_SUCCESS;
                 else {
                     done = TRUE;
                     start_data += newlen;
+                    irp_offset += newlen;
                     length -= newlen;
                     data = &((UINT8*)data)[newlen];
                 }
-            } else            
+            } else
                 ExReleaseResourceLite(&c->lock);
-        } else
-            ExReleaseResourceLite(&Vcb->chunk_lock);
-        
+        }
+
         if (!done) {
-            FIXME("FIXME - not enough room to write whole extent part, try to write bits and pieces\n"); // FIXME
-            break;
+            Status = insert_chunk_fragmented(fcb, start_data, length, data, FALSE, rollback);
+            if (!NT_SUCCESS(Status))
+                ERR("insert_chunk_fragmented returned %08x\n", Status);
+
+            return Status;
         }
     }
-    
-    WARN("couldn't find any data chunks with %llx bytes free\n", length);
 
     return STATUS_DISK_FULL;
 }
@@ -2973,16 +3230,73 @@
 
 NTSTATUS truncate_file(fcb* fcb, UINT64 end, PIRP Irp, LIST_ENTRY* rollback) {
     NTSTATUS Status;
-    
+
     // FIXME - convert into inline extent if short enough
-    
+
+    if (end > 0 && fcb_is_inline(fcb)) {
+        UINT8* buf;
+        BOOL make_inline = end <= fcb->Vcb->options.max_inline;
+
+        buf = ExAllocatePoolWithTag(PagedPool, (ULONG)(make_inline ? (offsetof(EXTENT_DATA, data[0]) + end) : sector_align(end, fcb->Vcb->superblock.sector_size)), ALLOC_TAG);
+        if (!buf) {
+            ERR("out of memory\n");
+            return STATUS_INSUFFICIENT_RESOURCES;
+        }
+
+        Status = read_file(fcb, make_inline ? (buf + offsetof(EXTENT_DATA, data[0])) : buf, 0, end, NULL, Irp);
+        if (!NT_SUCCESS(Status)) {
+            ERR("read_file returned %08x\n", Status);
+            ExFreePool(buf);
+            return Status;
+        }
+
+        Status = excise_extents(fcb->Vcb, fcb, 0, fcb->inode_item.st_size, Irp, rollback);
+        if (!NT_SUCCESS(Status)) {
+            ERR("excise_extents returned %08x\n", Status);
+            ExFreePool(buf);
+            return Status;
+        }
+
+        if (!make_inline) {
+            RtlZeroMemory(buf + end, (ULONG)(sector_align(end, fcb->Vcb->superblock.sector_size) - end));
+
+            Status = do_write_file(fcb, 0, sector_align(end, fcb->Vcb->superblock.sector_size), buf, Irp, FALSE, 0, rollback);
+            if (!NT_SUCCESS(Status)) {
+                ERR("do_write_file returned %08x\n", Status);
+                ExFreePool(buf);
+                return Status;
+            }
+        } else {
+            EXTENT_DATA* ed = (EXTENT_DATA*)buf;
+
+            ed->generation = fcb->Vcb->superblock.generation;
+            ed->decoded_size = end;
+            ed->compression = BTRFS_COMPRESSION_NONE;
+            ed->encryption = BTRFS_ENCRYPTION_NONE;
+            ed->encoding = BTRFS_ENCODING_NONE;
+            ed->type = EXTENT_TYPE_INLINE;
+
+            Status = add_extent_to_fcb(fcb, 0, ed, (UINT16)(offsetof(EXTENT_DATA, data[0]) + end), FALSE, NULL, rollback);
+            if (!NT_SUCCESS(Status)) {
+                ERR("add_extent_to_fcb returned %08x\n", Status);
+                ExFreePool(buf);
+                return Status;
+            }
+
+            fcb->inode_item.st_blocks += end;
+        }
+
+        ExFreePool(buf);
+        return STATUS_SUCCESS;
+    }
+
     Status = excise_extents(fcb->Vcb, fcb, sector_align(end, fcb->Vcb->superblock.sector_size),
                             sector_align(fcb->inode_item.st_size, fcb->Vcb->superblock.sector_size), Irp, rollback);
     if (!NT_SUCCESS(Status)) {
-        ERR("error - excise_extents failed\n");
+        ERR("excise_extents returned %08x\n", Status);
         return Status;
     }
-    
+
     fcb->inode_item.st_size = end;
     fcb->inode_item_changed = TRUE;
     TRACE("setting st_size to %llx\n", end);
@@ -2991,9 +3305,9 @@
     fcb->Header.FileSize.QuadPart = fcb->inode_item.st_size;
     fcb->Header.ValidDataLength.QuadPart = fcb->inode_item.st_size;
     // FIXME - inform cache manager of this
-    
+
     TRACE("fcb %p FileSize = %llx\n", fcb, fcb->Header.FileSize.QuadPart);
-    
+
     return STATUS_SUCCESS;
 }
 
@@ -3001,154 +3315,161 @@
     UINT64 oldalloc, newalloc;
     BOOL cur_inline;
     NTSTATUS Status;
-    
+
     TRACE("(%p, %p, %x, %u)\n", fcb, fileref, end, prealloc);
 
-    if (fcb->ads)
-        return stream_set_end_of_file_information(fcb->Vcb, end, fcb, fileref, NULL, FALSE, rollback);
-    else {
+    if (fcb->ads) {
+        if (end > 0xffff)
+            return STATUS_DISK_FULL;
+
+        return stream_set_end_of_file_information(fcb->Vcb, (UINT16)end, fcb, fileref, FALSE);
+    } else {
         extent* ext = NULL;
         LIST_ENTRY* le;
-        
+
         le = fcb->extents.Blink;
         while (le != &fcb->extents) {
             extent* ext2 = CONTAINING_RECORD(le, extent, list_entry);
-            
+
             if (!ext2->ignore) {
                 ext = ext2;
                 break;
             }
-            
+
             le = le->Blink;
         }
-        
+
         oldalloc = 0;
         if (ext) {
-            EXTENT_DATA* ed = ext->data;
+            EXTENT_DATA* ed = &ext->extent_data;
             EXTENT_DATA2* ed2 = (EXTENT_DATA2*)ed->data;
-            
-            if (ext->datalen < sizeof(EXTENT_DATA)) {
-                ERR("extent %llx was %u bytes, expected at least %u\n", ext->offset, ext->datalen, sizeof(EXTENT_DATA));
-                return STATUS_INTERNAL_ERROR;
-            }
-            
+
             oldalloc = ext->offset + (ed->type == EXTENT_TYPE_INLINE ? ed->decoded_size : ed2->num_bytes);
             cur_inline = ed->type == EXTENT_TYPE_INLINE;
-        
+
             if (cur_inline && end > fcb->Vcb->options.max_inline) {
                 UINT64 origlength, length;
                 UINT8* data;
-                UINT64 offset = ext->offset;
-                
+
                 TRACE("giving inline file proper extents\n");
-                
+
                 origlength = ed->decoded_size;
-                
+
                 cur_inline = FALSE;
-                
+
                 length = sector_align(origlength, fcb->Vcb->superblock.sector_size);
-                
-                data = ExAllocatePoolWithTag(PagedPool, length, ALLOC_TAG);
+
+                data = ExAllocatePoolWithTag(PagedPool, (ULONG)length, ALLOC_TAG);
                 if (!data) {
                     ERR("could not allocate %llx bytes for data\n", length);
                     return STATUS_INSUFFICIENT_RESOURCES;
                 }
-                
-                if (length > origlength)
-                    RtlZeroMemory(data + origlength, length - origlength);
-                
-                RtlCopyMemory(data, ed->data, origlength);
-                
-                fcb->inode_item.st_blocks -= origlength;
-                fcb->inode_item_changed = TRUE;
-                mark_fcb_dirty(fcb);
-                
-                remove_fcb_extent(fcb, ext, rollback);
-                
-                if (write_fcb_compressed(fcb)) {
-                    Status = write_compressed(fcb, offset, offset + length, data, Irp, rollback);
-                    if (!NT_SUCCESS(Status)) {
-                        ERR("write_compressed returned %08x\n", Status);
-                        ExFreePool(data);
-                        return Status;
-                    }
-                } else {
-                    Status = insert_extent(fcb->Vcb, fcb, offset, length, data, Irp, rollback);
-                    if (!NT_SUCCESS(Status)) {
-                        ERR("insert_extent returned %08x\n", Status);
-                        ExFreePool(data);
-                        return Status;
-                    }
+
+                Status = read_file(fcb, data, 0, origlength, NULL, Irp);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("read_file returned %08x\n", Status);
+                    ExFreePool(data);
+                    return Status;
                 }
-                
+
+                RtlZeroMemory(data + origlength, (ULONG)(length - origlength));
+
+                Status = excise_extents(fcb->Vcb, fcb, 0, fcb->inode_item.st_size, Irp, rollback);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("excise_extents returned %08x\n", Status);
+                    ExFreePool(data);
+                    return Status;
+                }
+
+                Status = do_write_file(fcb, 0, length, data, Irp, FALSE, 0, rollback);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("do_write_file returned %08x\n", Status);
+                    ExFreePool(data);
+                    return Status;
+                }
+
                 oldalloc = ext->offset + length;
-                
+
                 ExFreePool(data);
             }
-            
+
             if (cur_inline) {
-                ULONG edsize;
-                
+                UINT16 edsize;
+
                 if (end > oldalloc) {
-                    edsize = sizeof(EXTENT_DATA) - 1 + end - ext->offset;
+                    edsize = (UINT16)(offsetof(EXTENT_DATA, data[0]) + end - ext->offset);
                     ed = ExAllocatePoolWithTag(PagedPool, edsize, ALLOC_TAG);
-                    
+
                     if (!ed) {
                         ERR("out of memory\n");
                         return STATUS_INSUFFICIENT_RESOURCES;
                     }
-                    
-                    RtlZeroMemory(ed, edsize);
-                    RtlCopyMemory(ed, ext->data, ext->datalen);
-                    
+
+                    ed->generation = fcb->Vcb->superblock.generation;
                     ed->decoded_size = end - ext->offset;
-                    
+                    ed->compression = BTRFS_COMPRESSION_NONE;
+                    ed->encryption = BTRFS_ENCRYPTION_NONE;
+                    ed->encoding = BTRFS_ENCODING_NONE;
+                    ed->type = EXTENT_TYPE_INLINE;
+
+                    Status = read_file(fcb, ed->data, ext->offset, oldalloc, NULL, Irp);
+                    if (!NT_SUCCESS(Status)) {
+                        ERR("read_file returned %08x\n", Status);
+                        ExFreePool(ed);
+                        return Status;
+                    }
+
+                    RtlZeroMemory(ed->data + oldalloc - ext->offset, (ULONG)(end - oldalloc));
+
                     remove_fcb_extent(fcb, ext, rollback);
-                    
-                    if (!add_extent_to_fcb(fcb, ext->offset, ed, edsize, ext->unique, NULL, rollback)) {
-                        ERR("add_extent_to_fcb failed\n");
+
+                    Status = add_extent_to_fcb(fcb, ext->offset, ed, edsize, ext->unique, NULL, rollback);
+                    if (!NT_SUCCESS(Status)) {
+                        ERR("add_extent_to_fcb returned %08x\n", Status);
                         ExFreePool(ed);
-                        return STATUS_INTERNAL_ERROR;
+                        return Status;
                     }
-                    
+
+                    ExFreePool(ed);
+
                     fcb->extents_changed = TRUE;
                     mark_fcb_dirty(fcb);
                 }
-                
+
                 TRACE("extending inline file (oldalloc = %llx, end = %llx)\n", oldalloc, end);
-                
+
                 fcb->inode_item.st_size = end;
                 TRACE("setting st_size to %llx\n", end);
-                
+
                 fcb->inode_item.st_blocks = end;
 
                 fcb->Header.AllocationSize.QuadPart = fcb->Header.FileSize.QuadPart = fcb->Header.ValidDataLength.QuadPart = end;
             } else {
                 newalloc = sector_align(end, fcb->Vcb->superblock.sector_size);
-            
+
                 if (newalloc > oldalloc) {
                     if (prealloc) {
                         // FIXME - try and extend previous extent first
-                        
+
                         Status = insert_prealloc_extent(fcb, oldalloc, newalloc - oldalloc, rollback);
-                    
+
                         if (!NT_SUCCESS(Status)) {
                             ERR("insert_prealloc_extent returned %08x\n", Status);
                             return Status;
                         }
                     }
-                    
+
                     fcb->extents_changed = TRUE;
                 }
-                
+
                 fcb->inode_item.st_size = end;
                 fcb->inode_item_changed = TRUE;
                 mark_fcb_dirty(fcb);
-                
+
                 TRACE("setting st_size to %llx\n", end);
-                
+
                 TRACE("newalloc = %llx\n", newalloc);
-                
+
                 fcb->Header.AllocationSize.QuadPart = newalloc;
                 fcb->Header.FileSize.QuadPart = fcb->Header.ValidDataLength.QuadPart = end;
             }
@@ -3155,39 +3476,39 @@
         } else {
             if (end > fcb->Vcb->options.max_inline) {
                 newalloc = sector_align(end, fcb->Vcb->superblock.sector_size);
-            
+
                 if (prealloc) {
                     Status = insert_prealloc_extent(fcb, 0, newalloc, rollback);
-                    
+
                     if (!NT_SUCCESS(Status)) {
                         ERR("insert_prealloc_extent returned %08x\n", Status);
                         return Status;
                     }
                 }
-                
+
                 fcb->extents_changed = TRUE;
                 fcb->inode_item_changed = TRUE;
                 mark_fcb_dirty(fcb);
-                
+
                 fcb->inode_item.st_size = end;
                 TRACE("setting st_size to %llx\n", end);
-                
+
                 TRACE("newalloc = %llx\n", newalloc);
-                
+
                 fcb->Header.AllocationSize.QuadPart = newalloc;
                 fcb->Header.FileSize.QuadPart = fcb->Header.ValidDataLength.QuadPart = end;
             } else {
                 EXTENT_DATA* ed;
-                ULONG edsize;
-                
-                edsize = sizeof(EXTENT_DATA) - 1 + end;
+                UINT16 edsize;
+
+                edsize = (UINT16)(offsetof(EXTENT_DATA, data[0]) + end);
                 ed = ExAllocatePoolWithTag(PagedPool, edsize, ALLOC_TAG);
-                
+
                 if (!ed) {
                     ERR("out of memory\n");
                     return STATUS_INSUFFICIENT_RESOURCES;
                 }
-                
+
                 ed->generation = fcb->Vcb->superblock.generation;
                 ed->decoded_size = end;
                 ed->compression = BTRFS_COMPRESSION_NONE;
@@ -3194,22 +3515,25 @@
                 ed->encryption = BTRFS_ENCRYPTION_NONE;
                 ed->encoding = BTRFS_ENCODING_NONE;
                 ed->type = EXTENT_TYPE_INLINE;
-                
-                RtlZeroMemory(ed->data, end);
-                
-                if (!add_extent_to_fcb(fcb, 0, ed, edsize, FALSE, NULL, rollback)) {
-                    ERR("add_extent_to_fcb failed\n");
+
+                RtlZeroMemory(ed->data, (ULONG)end);
+
+                Status = add_extent_to_fcb(fcb, 0, ed, edsize, FALSE, NULL, rollback);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("add_extent_to_fcb returned %08x\n", Status);
                     ExFreePool(ed);
-                    return STATUS_INTERNAL_ERROR;
+                    return Status;
                 }
-                
+
+                ExFreePool(ed);
+
                 fcb->extents_changed = TRUE;
                 fcb->inode_item_changed = TRUE;
                 mark_fcb_dirty(fcb);
-                
+
                 fcb->inode_item.st_size = end;
                 TRACE("setting st_size to %llx\n", end);
-                
+
                 fcb->inode_item.st_blocks = end;
 
                 fcb->Header.AllocationSize.QuadPart = fcb->Header.FileSize.QuadPart = fcb->Header.ValidDataLength.QuadPart = end;
@@ -3216,51 +3540,43 @@
             }
         }
     }
-    
+
     return STATUS_SUCCESS;
 }
 
 static NTSTATUS do_write_file_prealloc(fcb* fcb, extent* ext, UINT64 start_data, UINT64 end_data, void* data, UINT64* written,
-                                       PIRP Irp, LIST_ENTRY* rollback) {
-    EXTENT_DATA* ed = ext->data;
+                                       PIRP Irp, BOOL file_write, UINT64 irp_offset, ULONG priority, LIST_ENTRY* rollback) {
+    EXTENT_DATA* ed = &ext->extent_data;
     EXTENT_DATA2* ed2 = (EXTENT_DATA2*)ed->data;
     NTSTATUS Status;
-    chunk* c;
-    
+    chunk* c = NULL;
+
     if (start_data <= ext->offset && end_data >= ext->offset + ed2->num_bytes) { // replace all
-        EXTENT_DATA* ned;
         extent* newext;
-        
-        ned = ExAllocatePoolWithTag(PagedPool, ext->datalen, ALLOC_TAG);
-        if (!ned) {
-            ERR("out of memory\n");
-            return STATUS_INSUFFICIENT_RESOURCES;
-        }
-        
-        newext = ExAllocatePoolWithTag(PagedPool, sizeof(extent), ALLOC_TAG);
+
+        newext = ExAllocatePoolWithTag(PagedPool, offsetof(extent, extent_data) + ext->datalen, ALLOC_TAG);
         if (!newext) {
             ERR("out of memory\n");
-            ExFreePool(ned);
             return STATUS_INSUFFICIENT_RESOURCES;
         }
-        
-        RtlCopyMemory(ned, ext->data, ext->datalen);
-        
-        ned->type = EXTENT_TYPE_REGULAR;
-        
-        Status = write_data_complete(fcb->Vcb, ed2->address + ed2->offset, (UINT8*)data + ext->offset - start_data, ed2->num_bytes, Irp, NULL);
+
+        RtlCopyMemory(&newext->extent_data, &ext->extent_data, ext->datalen);
+
+        newext->extent_data.type = EXTENT_TYPE_REGULAR;
+
+        Status = write_data_complete(fcb->Vcb, ed2->address + ed2->offset, (UINT8*)data + ext->offset - start_data, (UINT32)ed2->num_bytes, Irp,
+                                     NULL, file_write, irp_offset + ext->offset - start_data, priority);
         if (!NT_SUCCESS(Status)) {
             ERR("write_data_complete returned %08x\n", Status);
             return Status;
         }
-        
+
         if (!(fcb->inode_item.flags & BTRFS_INODE_NODATASUM)) {
-            ULONG sl = ed2->num_bytes / fcb->Vcb->superblock.sector_size;
+            ULONG sl = (ULONG)(ed2->num_bytes / fcb->Vcb->superblock.sector_size);
             UINT32* csum = ExAllocatePoolWithTag(PagedPool, sl * sizeof(UINT32), ALLOC_TAG);
-            
+
             if (!csum) {
                 ERR("out of memory\n");
-                ExFreePool(ned);
                 ExFreePool(newext);
                 return STATUS_INSUFFICIENT_RESOURCES;
             }
